# Copyright (C) 2004 NEC Corporation
# All Rights Reserved.

# RCS: $Id: common.pl,v 3.14 2004/03/01 wbmc Exp $


# 󥹥ȡǥ쥯ȥ
$WBMC_INSTALL_DIR = "/opt/nec/wbmc";


#
# ̾
#	readParam - եफΥѥ᡼ɤ߹
# 
#	readParam()
# 
#	ʤ
# 
#	ΤȤʸ
#	ԤΤȤ顼å
#
sub readParam
{
    local($err, $buf, $name, $value);

    if ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
    } elsif ($ENV{'REQUEST_METHOD'} eq "GET") {
	$buf = $ENV{'QUERY_STRING'};
    } else {
	$err = "Invalid request method.";
	return($err);
    }

    foreach (split(/&/, $buf)) {
	($name, $value) = split(/=/);
	$value =~ tr/+/ /;
	$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
    }

    return($err);
}

#
# ̾
#	showErrorPage - 顼åɽ
# 
#	showErrorPage($message, $page)
# 
#	$message ɽ륨顼å
#		ꤷʤ""ꤹȡ"ϼԤޤ"ɽ
#	$page ܥ򲡤Ȥɽڡ
#		ꤷʤ""ꤹȡΥڡɽ
# 
#	ʤ
#
sub showErrorPage
{
    my($message, $page) = @_;
    my($msg);

    if (!defined($message) || $message eq "") {
	$msg = "ϼԤޤ";
    } else {
	$msg = $message;
    }

    &showMessagePage("顼", $msg, $page);
}

#
# ̾
#	showResultPage - ()ɽ
# 
#	showResultPage($message, $page, $page2)
# 
#	$message ɽ̥å
#		ꤷʤ""ꤹȡ"ޤ"ɽ
#	$page ܥ򲡤Ȥɽڡ
#		ꤷʤ""ꤹȡΥڡɽ
#	$page2 ɲåܥ򲡤Ȥɽڡ
#		ꤷʤ""ꤹȡܥΤɽʤ
# 
#	ʤ
#
sub showResultPage
{
    my($message, $page, $page2) = @_;
    my($msg);

    if (!defined($message) || $message eq "") {
	$msg = "ޤ";
    } else {
	$msg = $message;
    }

    &showMessagePage("", $msg, $page, $page2);
}

#
# ̾
#	showMessagePage - åɽ()
#			showErrorPageshowResultPageμ
# 
#	showMessagePage($title, $message, $page, $page2)
# 
#	$title ɽ륿ȥ
#	$message ɽå
#	$page ܥ򲡤Ȥɽڡ
#		ꤷʤ""ꤹȡΥڡɽ
#	$page2 ɲåܥ򲡤Ȥɽڡ
#		ꤷʤ""ꤹȡܥΤɽʤ
# 
#	ʤ
#
sub showMessagePage
{
    my($title, $message, $page, $page2) = @_;
    my($newpage, $newpage2);

    if (!defined($page) || $page eq "") {
	$newpage = "history.back()";
    } else {
	$newpage = "location.href='$page'";
    }

    if (!defined($page2) || $page2 eq "") {
	$newpage2 = "";
    } else {
	$newpage2 = "<INPUT TYPE='button' VALUE='ɲ' onClick=\"location.href='$page2'\">";
    }

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY>
<H4 ALIGN="center">$title</H4>
<HR>

<CENTER>
 <FORM>
  <TABLE BGCOLOR="#CCCCCC" WIDTH=300 BORDER=1 CELLSPACING=0 CELLPADDING=1>
   <TR BGCOLOR="#000080">
    <TD>
     <FONT COLOR="#FFFFFF"> <B>$title</B></FONT>
    </TD>
   </TR>
   <TR>
    <TD>
     <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD>
        $message
       </TD>
      </TR>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD ALIGN="center">
        <INPUT TYPE="button" VALUE="" onClick=$newpage>
        $newpage2
       </TD>
      </TR>
     </TABLE>
    </TD>
   </TR>
  </TABLE>
 </FORM>
</CENTER>

<HR>
$COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------
}

#
# ̾
#	showPage - ꤵ줿ڡ򳫤
# 
#	showPage($page)
# 
#	$page ڡ("/"ǻϤޤʤиƤӽФڡβۥѥղä)
# 
#	ʤ
#
sub showPage
{
    local($page) = @_;
    my($path);

    if (defined($ENV{'HTTPS'}) && $ENV{'HTTPS'} eq "on") {
	$path = "https://";
    } else {
	$path = "http://";
    }

    $path .= $ENV{'HTTP_HOST'};

    if ($page =~ /^\//) {
	$path .= $page;
    } else {
	$path .= &getScriptPath() . "/$page";
    }
#------------------------------------------------------------
print <<END_OF_DATA;
Location: $path

END_OF_DATA
#------------------------------------------------------------
}

#
# ̾
#	getScriptPath - ץȤβۥѥ
# 
#	getScriptPath()
# 
#	ʤ
# 
#	ץȤβۥѥ(ʸ)
#
sub getScriptPath
{
    local($script);

    $script = $ENV{'SCRIPT_NAME'};
    $script =~ s|/[^/]+$||;
    return($script);
}

#
# ̾
#	getDate - ߤλ
# 
#	getDate()
# 
#	ʤ
# 
#	ߤλ(ʸ)
#
sub getDate
{
    local($year, $mon, $mday, $hour, $min, $sec);

    ($sec, $min, $hour, $mday, $mon, $year) = localtime();
    return(sprintf("%04d/%02d/%02d %02d:%02d:%02d",
	$year + 1900, $mon + 1, $mday, $hour, $min, $sec));
}

#
# ̾
#	ipAddrCheck - IPɥ쥹Υ󥿥ååԤ
# 
#	ipAddrCheck($addr)
# 
#	$addr ɥåɽIPɥ쥹
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub ipAddrCheck
{
    local($addr) = @_;

    if ($addr !~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
	return(0);
    }

    if (($1 < 0) || (255 < $1)
     || ($2 < 0) || (255 < $2)
     || ($3 < 0) || (255 < $3)
     || ($4 < 0) || (255 < $4)) {
	return(0);
    }

    return(1);
}

#
# ̾
#	ipStr2Addr - IPɥ쥹ʸ󤫤ͤѴ
# 
#	ipStr2Addr($addr)
# 
#	$addr ɥåɽIPɥ쥹
# 
#	ͤȤƤIPɥ쥹
#
sub ipStr2Addr
{
    local($addr) = @_;
    local(@ent);

    @ent = split(/\./, $addr);

    return($ent[0] * 256 * 256 * 256
	 + $ent[1] * 256 * 256
	 + $ent[2] * 256
	 + $ent[3]);
}

#
# ̾
#	ipAddr2Str - IPɥ쥹ͤʸѴ
# 
#	ipAddr2Str($addr)
# 
#	$addr ͤȤƤIPɥ쥹
# 
#	ɥåɽIPɥ쥹
#
sub ipAddr2Str
{
    local($addr) = @_;

    return(sprintf("%d.%d.%d.%d",
	($addr & 0xff000000) / (256 * 256 * 256),
	($addr & 0x00ff0000) / (256 * 256),
	($addr & 0x0000ff00) / (256),
	($addr & 0x000000ff)));
}

#
# ̾
#	getNetMask - IPɥ쥹ǥեȤΥͥåȥޥ
# 
#	getNetMask($netaddr)
# 
#	$netaddr ɥåɽIPɥ쥹
# 
#	ɥåɽΥͥåȥޥ
#
sub getNetMask
{
    my($netaddr) = @_;
    my($netaddrnum);
    my($netmask);

    $netaddrnum = &ipStr2Addr($netaddr);
    if (($netaddrnum & 0x80000000) == 0) {
	# 饹A
	$netmask = "255.0.0.0";
    } elsif (($netaddrnum & 0xc0000000) == 0x80000000) {
	# 饹B
	$netmask = "255.255.0.0";
    } elsif (($netaddrnum & 0xe0000000) == 0xc0000000) {
	# 饹C
	$netmask = "255.255.255.0";
    } else {
	# ¾
	$netmask = "";
    }

    return($netmask);
}

# եåΥ⡼
$WBMC_LOCK_R_B = 1;	# ɤ߹ߥå(֥å⡼)
$WBMC_LOCK_W_B = 2;	# 񤭹ߥå(֥å⡼)
$WBMC_LOCK_R_NB = 5;	# ɤ߹ߥå(Υ֥å⡼)
$WBMC_LOCK_W_NB = 6;	# 񤭹ߥå(Υ֥å⡼)

#
# ̾
#	lockFile - ꤵ줿ե˥å򤫤
# 
#	lockFile($lockfile, $mode, *LOCK)
# 
#	$lockfile åե̾(/opt/nec/wbmc/adm/service/ESMPRO_AC/β˺)
#	$mode åΥ⡼(β줫)
#		$WBMC_LOCK_R_B  ɤ߹ߥå(֥å⡼)
#		$WBMC_LOCK_W_B  񤭹ߥå(֥å⡼)
#		$WBMC_LOCK_R_NB ɤ߹ߥå(Υ֥å⡼)
#		$WBMC_LOCK_W_NB 񤭹ߥå(Υ֥å⡼)
#	*LOCK եϥɥ
#		åˤϤΥեϥɥclose
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub lockFile
{
    local($lockfile, $mode, *LOCK) = @_;

    my($ret);
    my($lockdir);

    $ret = 0;
    $lockdir = $ESMAC_LOCKDIR;

    if ($lockfile eq "") {
	goto done;
    }

    # åեѤΥǥ쥯ȥ(̵)
    if (! -d $lockdir) {
	if (!mkdir($lockdir, 0755)) {
	    goto done;
	}
    }

    # åե򥪡ץ󤹤
    if (!open(LOCK, "> $lockdir/$lockfile")) {
	goto done;
    }

    # å򤫤
    if (!flock(LOCK, $mode)) {
	close(LOCK);
	goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	readFile - եɤƤ֤(åդ)
# 
#	readFile($filename, $lockfile, *line)
# 
#	$filename ɤ߹ե̾
#	$lockfile åե̾(/opt/nec/wbmc/adm/service/ESMPRO_AC/β˺)
#	*line եƤ
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub readFile
{
    local($filename, $lockfile, *line) = @_;

    local(*LOCK);
    local(*IN);
    my($ret);
    my($lockfileflag);

    $ret = 0;
    $lockfileflag = 0;

    if ($filename eq "") {
	goto done;
    }

    if ($lockfile ne "") {
	# ɤ߹ߥå(֥å⡼)򤫤
	if (!&lockFile($lockfile, $WBMC_LOCK_R_B, *LOCK)) {
	    goto done;
	}
	$lockfileflag = 1;
    }

    # ե򥪡ץ󤷤ɤ߹
    if (!open(IN, $filename)) {
	goto done;
    }
    @line = <IN>;
    close(IN);

    $ret = 1;

done:
    if ($lockfileflag != 0) {
	close(LOCK);
    }

    return($ret);
}

#
# ̾
#	writeFile - ꤵ줿Ƥե˽񤭹(åդ)
# 
#	writeFile($filename, $lockfile, @line)
# 
#	$filename 񤭹ե̾
#	$lockfile åե̾(/opt/nec/wbmc/adm/service/ESMPRO_AC/β˺)
#	@line ե˽񤭹Ƥ
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub writeFile
{
    local($filename, $lockfile, @line) = @_;

    local(*LOCK);
    local(*OUT);
    my($ret);
    my($lockfileflag);
    my($tmpfile);
    my($filemode);

    $ret = 0;
    $lockfileflag = 0;
    $tmpfile = "$filename.$$";

    if ($filename eq "") {
	goto done;
    }

    if ($lockfile ne "") {
	# 񤭹ߥå(֥å⡼)򤫤
	if (!&lockFile($lockfile, $WBMC_LOCK_W_B, *LOCK)) {
	    goto done;
	}
	$lockfileflag = 1;
    }

    # ȥե򥪡ץ󤷤ƽ񤭹
    if (!open(OUT, "> $tmpfile")) {
	goto done;
    }
    if (!print(OUT @line)) {
	close(OUT);
	goto done;
    }
    close(OUT);

    # եΥ⡼ɤ
    if (-e $filename) {
	$filemode = (stat($filename))[2];
    } else {
	$filemode = 0644;
    }

    # Υե˥͡ह
    if (!rename($tmpfile, $filename)) {
	goto done;
    }

    # եΥ⡼ɤꤹ
    chmod($filemode & 07777, $filename);

    $ret = 1;

done:
    if ($lockfileflag != 0) {
	close(LOCK);
    }

    if (-f $tmpfile) {
	unlink($tmpfile);
    }

    return($ret);
}

#
# ̾
#	getNavigation - ʥӥС֤
# 
#	getNavigation($name1, $page2, $name2, $page2, ...)
# 
#	$nameN ɽ̾
#		_backб
#		_helpϥإפб
#	$pageN Ȥɽڡ
#		ꤷʤ""ꤹȡ󥯤ɽʤ
#		ΤȤ_back_helpξ̾ɽʤ
# 
#	ʥӥС(ʸ)
#
sub getNavigation
{
    my(@argv) = @_;

    my(@name);
    my(@page);
    my($backpage);
    my($helppage);
    my($i);
    my($buf);

    $backpage = "";
    $helppage = "";
    for ($i = 0; $i <= $#argv; $i++) {
	if ($argv[$i] eq "_back") {
	    if (($i + 1) <= $#argv) {
		$backpage = $argv[$i + 1];
		$i++;
	    }
	} elsif ($argv[$i] eq "_help") {
	    if (($i + 1) <= $#argv) {
		$helppage = $argv[$i + 1];
		$i++;
	    }
	} else {
	    push(@name, $argv[$i]);
	    if (($i + 1) <= $#argv) {
		push(@page, $argv[$i + 1]);
		$i++;
	    } else {
		push(@page, "");
	    }
	}
    }

    $buf = ""
	. "<TABLE WIDTH='100%'>\n"
	. " <TR>\n"
	. "  <TD ALIGN='left'>\n";

    for ($i = 0; $i <= $#name; $i++) {
	if ($page[$i] ne "") {
	    $buf .= "   <A HREF='$page[$i]'>$name[$i]</A> &gt;\n";
	} else {
	    $buf .= "   $name[$i]\n";
	}
    }

    $buf .= ""
	. "  </TD>\n"
	. "  <TD ALIGN='right'>\n";

    if ($backpage ne "") {
	$buf .= "   <A HREF='$backpage'>[]</A>\n";
    }
    if ($helppage ne "") {
	$buf .= "   <A HREF='$helppage' TARGET='help'>[إ]</A>\n";
    }

    $buf .= ""
	. "  </TD>\n"
	. " </TR>\n"
	. "</TABLE>\n";

    return($buf);
}

#
# ̾
#	parseUint - Ϥ줿ͤå
# 
#	parseUint($str)
# 
#	$str ʸ(ζʸ̵뤹)
# 
#	ΤȤ(0ʾ)
#	ԤΤȤ-1
#
sub parseUint
{
    my($str) = @_;
    my($num);

    $str =~ s/^\s*//;
    $str =~ s/\s*$//;

    if ($str =~ /[^0-9]/) {
	$num = -1;
    } else {
	$str =~ s/^0+//;
	if ($str eq "") {
	    $num = 0;
	} else {
	    $num = $str;
	}
    }

    return($num);
}

#
# ̾
#	isServiceRunning - ӥư椫ɤǧ
# 
#	isServiceRunning($dir)
# 
#	$dir Υӥ wbmc.rc Τǥ쥯ȥ
#		ꤷʤ""ꤹȡȥǥ쥯ȥȤߤʤ
# 
#	ưΤȤ1
#	ΤȤ0
#	ΤȤ-1
#
sub isServiceRunning
{
    my($dir) = @_;

    local(@inetd_conf);
    local(@wbmc_rc);
    my(@ent);
    my(%inetd_conf);
    my(%process);
    my($filename);
    my($service_type);
    my($service_name);
    my($upcheck);
    my($process_name);
    my($updown_current);

    $updown_current = "unknown";

    # inetd.confƤɤߤƤ
    if (!&readFile("/etc/inetd.conf", "inetd.conf", *inetd_conf)) {
	goto nextstep1;
    }
    for (@inetd_conf) {
	s/^\s*//;
	s/\s*$//;
	if (/^#/) {
	    next;
	}
	@ent = split(/\s+/);
	if ($ent[1] !~ /^(stream|dgram)$/) {
	    next;
	}
	$inetd_conf{$ent[0]} = 1;
    }

nextstep1:

    # psη̤ɤߤƤ
    if (!open(IN, "/bin/ps -efwwwww |")) {
	goto nextstep2;
    }
    while (<IN>) {
	s/\s*$//;
	@ent = split(/\s+/);
	$ent[7] =~ s/\[//;
	$ent[7] =~ s/\]//;
	$ent[7] =~ s/.*\///;
	$process{$ent[7]} = 1;
    }
    close(IN);

nextstep2:

    if (defined($dir) && $dir ne "") {
	$filename = "$dir/wbmc.rc";
    } else {
	$filename = "./wbmc.rc";
    }

    # wbmc.rc եɤ߹
    if (!&readFile($filename, "wbmc.rc", *wbmc_rc)) {
	goto nextstep3;
    }
    $service_type = "";
    $service_name = "";
    $upcheck = "";
    $process_name = "";
    for (@wbmc_rc) {
	s/\s*$//;
	if (/^#/) {
	    next;
	}
	elsif (/^\s*ServiceType:\s*(.*)/i) {
	    $service_type = $1;
	}
	elsif (/^\s*ServiceName:\s*(.*)/i) {
	    $service_name = $1;
	}
	elsif (/^\s*UpCheck:\s*(.*)/i) {
	    $upcheck = $1;
	}
	elsif (/^\s*ProcessName:\s*(.*)/i) {
	    $process_name = $1;
	}
    }

    # ӥפ inetd Ǥʤ rc Ȥߤʤ
    if ($service_type !~ /^inetd$/i) {
	$service_type = "rc";
    }

    # ߤξ֤
    if ($upcheck) {
#	chdir($dir);
	if ($upcheck !~ /^\//) {
	    if (defined($dir) && $dir ne "") {
		$upcheck = "$dir/$upcheck";
	    } else {
		$upcheck = "./$upcheck";
	    }
	}
	if (open(IN, "$upcheck |")) {
	    $updown_current = <IN>;
	    $updown_current =~ s/\s*$//;
	    close(IN);
	}
#	chdir("..");
    } elsif ($service_type =~ /^inetd$/i) {
	if ($inetd_conf{$service_name}) {
	    $updown_current = "up";
	} else {
	    $updown_current = "down";
	}
    } else {
	if ($process_name) {
	    if ($process{$process_name}) {
		$updown_current = "up";
	    } else {
		$updown_current = "down";
	    }
	}
    }

nextstep3:

    if ($updown_current eq "up") {
	return(1);
    } elsif ($updown_current eq "down") {
	return(0);
    } else {
	return(-1);
    }
}

#
# ̾
#	checkNum - ͤꤵ줿ϰϤˤ뤫ɤå
# 
#	checkNum($num, $min, $max)
# 
#	$num 
#	$min Ǿ
#	$max 
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkNum
{
    my($num, $min, $max) = @_;
    my($ret);

    $ret = 0;

    if (!defined($num) || $num eq "") {
	goto done;
    }
    if ($num =~ /\D+/) {
	goto done;
    }
    if ($num < $min || $num > $max) {
	goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	checkNetMask - ֥ͥåȥޥηå
# 
#	checkNetMask($netmask)
# 
#	$netmask ֥ͥåȥޥ
#		(ɥåɽ131)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkNetMask
{
    my($netmask) = @_;
    my($ret);

    $ret = 0;

    if (!defined($netmask) || $netmask eq "") {
	goto done;
    }
    if ($netmask =~ /\./) {
	if (!&ipAddrCheck($netmask)) {
	    goto done;
	}
    } else {
	if (!&checkNum($netmask, 1, 31)) {
	    goto done;
	}
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	checkPortNum - ݡֹηå
# 
#	checkPortNum($port)
# 
#	$port ݡֹ
#		(165535)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkPortNum
{
    my($port) = @_;

    return(&checkNum($port, 1, 65535));
}

#
# ̾
#	checkUserID - 桼IDηå
# 
#	checkUserID($uid)
# 
#	$uid 桼ID
#		(065534)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkUserID
{
    my($uid) = @_;

    return(&checkNum($uid, 0, 65534));
}

#
# ̾
#	checkGroupID - 롼IDηå
# 
#	checkGroupID($gid)
# 
#	$gid 롼ID
#		(065534)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkGroupID
{
    my($gid) = @_;

    return(&checkNum($gid, 0, 65534));
}

#
# ̾
#	checkName - ̾ηå
# 
#	checkName($name)
# 
#	$name ̾
#		(ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_')
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkName
{
    my($name) = @_;
    my($ret);

    $ret = 0;

    if (!defined($name) || $name eq "") {
	goto done;
    }
    if ($name =~ /^[^A-Za-z]/) {
	goto done;
    }
    if ($name =~ /[^A-Za-z0-9\-\._]/) {
	goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	checkUserName - 桼̾ηå
# 
#	checkUserName($user)
# 
#	$user 桼̾
#		(ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_')
#		(Ĺ132)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkUserName
{
    my($user) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if(!&checkName($user)) {
	goto done;
    }
    $len = length($user);
    if(!&checkNum($len, 1, 32)) {
	goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	checkGroupName - 롼̾ηå
# 
#	checkGroupName($group)
# 
#	$group 롼̾
#		(ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_')
#		(Ĺ116)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkGroupName
{
    my($group) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if(!&checkName($group)) {
	goto done;
    }
    $len = length($group);
    if(!&checkNum($len, 1, 16)) {
	goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	checkShortHostName - ۥ̾ηå
# 
#	checkShortHostName($host)
# 
#	$host ۥ̾
#		(ƬA-Z, a-zǡA-Z, a-z, 0-9ǡ
#		ΤA-Z, a-z, 0-9, '-')
#		(Ĺ163)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkShortHostName
{
    my($host) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if (!defined($host) || $host eq "") {
	goto done;
    }

    $len = length($host);
    if (!&checkNum($len, 1, 63)) {
	goto done;
    }

    if ($host =~ /^[^A-Za-z]/) {
	goto done;
    }
    if ($host =~ /[^A-Za-z0-9]$/) {
	goto done;
    }
    if ($host =~ /[^A-Za-z0-9\-]/) {
	goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	checkLongHostName - ۥ̾(FQDN)ηå
# 
#	checkLongHostName($host)
# 
#	$host ۥ̾
#		('.'ǶڤäȤƬA-Z, a-zǡA-Z, a-z, 0-9ǡ
#		ΤA-Z, a-z, 0-9, '-')
#		(Ĺϸġ163Ĺ163)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkLongHostName
{
    my($host) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if (!&checkDomainName($host)) {
	goto done;
    }
    $len = length($host);
    if (!&checkNum($len, 1, 63)) {
	goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	checkDomainName - ɥᥤ̾ηå
# 
#	checkDomainName($domain)
# 
#	$domain ɥᥤ̾
#		('.'ǶڤäȤƬA-Z, a-zǡA-Z, a-z, 0-9ǡ
#		ΤA-Z, a-z, 0-9, '-')
#		(Ĺϸġ163Ĺ1255)
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub checkDomainName
{
    my($domain) = @_;
    my($ret);
    my($len);
    my(@ent);
    my($i);

    $ret = 0;

    if (!defined($domain) || $domain eq "") {
	goto done;
    }
    if ($domain =~ /^\./) {
	goto done;
    }
    if ($domain =~ /\.$/) {
	goto done;
    }

    $len = length($domain);
    if (!&checkNum($len, 1, 255)) {
	goto done;
    }

    @ent = split(/\./, $domain);
    for ($i = 0; $i <= $#ent; $i++) {
	$len = length($ent[$i]);
	if (!&checkNum($len, 1, 63)) {
	    goto done;
	}

	if ($ent[$i] =~ /^[^A-Za-z]/) {
	    goto done;
	}
	if ($ent[$i] =~ /[^A-Za-z0-9]$/) {
	    goto done;
	}
	if ($ent[$i] =~ /[^A-Za-z0-9\-]/) {
	    goto done;
	}
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#	encodeHtml - HTMLΥ󥳡(&  &amp;)Ԥ
# 
#	encodeHtml($str)
# 
#	$str ʸ
# 
#	󥳡ɤ줿ʸ
#
sub encodeHtml
{
    my($str) = @_;

    $str =~ s/&/&amp;/g;
    $str =~ s/</&lt;/g;
    $str =~ s/>/&gt;/g;
    $str =~ s/"/&quot;/g;
    return($str);
}

#
# ̾
#	encodeCmdArg - ޥɥ饤Υ󥳡(&  \&)Ԥ
# 
#	encodeCmdArg($str)
# 
#	$str ʸ
# 
#	󥳡ɤ줿ʸ
#
sub encodeCmdArg
{
    my($str) = @_;

    $str =~ s/([^0-9a-zA-Z])/\\$1/g;
    return($str);
}

#
# ̾
#	encodeUrl - URLΥ󥳡(&  %26)Ԥ
# 
#	encodeUrl($str)
# 
#	$str ʸ
# 
#	󥳡ɤ줿ʸ
#
sub encodeUrl
{
    my($str) = @_;

    $str =~ s/([^\-\_\.\/0-9a-zA-Z])/sprintf("%%%02X", ord($1))/eg;
    return($str);
}

1;

