#!/usr/bin/perl

# Copyright (C) 2001 NEC Corporation
# All Rights Reserved.

# RCS: $Id: set_ejob.cgi,v 1.10 2001/12/06  wbmc Exp $


#---------------------------------------------------------------------------
require "./esmac.pl";
require "$COMMONAPIS";

#---------------------------------------------------------------------------
# ե졼ե
#---------------------------------------------------------------------------
$cfname = $WBMC_SHUTDOWN_REQUEST_FILE;

#---------------------------------------------------------------------------
# ե񤭹
#---------------------------------------------------------------------------
if (!&lockFile($NAMEDLOCKFILE, "$WBMC_LOCK_W_B", *LOCK)) {
	$err = "$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
	&showErrorPage("$err");
	exit(1);
}

$tmpcfname = "$cfname\.tmp";
if (!open(OUT, "> $tmpcfname")) {
	close(LOCK);
	$err = "$STR_ERR_CANTOPENFILE($tmpcfname)";
	&showErrorPage("$err");
	exit(1);
}
$fp = OUT;
$string = "";
$string = sprintf( "%s\n", $WBMC_SHUTDOWN_REQUEST_TEXT );
$len = length( $string );
$err = syswrite( $fp, $string, $len );

close(OUT);

close(LOCK);

if ($err == $len) {
	rename($tmpcfname, $cfname);
}
else {
	unlink($tmpcfname);
	$err = "$STR_ERR_CANTWRITEFILE($tmpcfname)";
	&showErrorPage("$err");
	exit(1);
}



&showResultPage("", "esmac.cgi");
exit(0);
#---------------------------------------------------------------------------
