#!/usr/bin/perl

# Copyright (C) 2001 NEC Corporation
# All Rights Reserved.

# RCS: $Id: set_job.cgi,v 3.17 2003/1/27  wbmc Exp $


#---------------------------------------------------------------------------
require "./esmac.pl";
require "$COMMONAPIS";

#---------------------------------------------------------------------------
# Ÿεư֤
#---------------------------------------------------------------------------
$cfname = $STARTJOBCONFIG;

&readParam();

$jobs = $FORM{'START_JOB'};

$jobs =~ s/,/ /;
$jobs =~ s/^\s*//;
$jobs =~ s/^\t*//;
$jobs =~ s/\s*$//;
$jobs =~ s/\r//g;
$jobs =~ s/\n\s*/\n/g;

if (!&lockFile($NAMEDLOCKFILE, "$WBMC_LOCK_W_B", *LOCK)) {
	$err = "$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
	&showErrorPage("$err");
	exit(1);
}

$tmpcfname = "$cfname\.tmp";
if (!open(OUT, "> $tmpcfname")) {
	close(LOCK);
	$err = "$STR_ERR_CANTOPENFILE($tmpcfname)";
	&showErrorPage("$err");
	exit(1);
}
$fp = OUT;
$string = "";
$string = sprintf( "%s\n", $jobs );
$len = length( $string );
$err = syswrite( $fp, $string, $len );

close(OUT);

close(LOCK);

if ($err == $len) {
	rename($tmpcfname, $cfname);
}
else {
	unlink($tmpcfname);
	$err = "$STR_ERR_CANTWRITEFILE($tmpcfname)";
	&showErrorPage("$err");
	exit(1);
}

#---------------------------------------------------------------------------
# Ÿǻεư
#---------------------------------------------------------------------------
$cfname = $ENDJOBCONFIG;

&readParam();

$jobs = $FORM{'END_JOB'};
$jobs =~ s/,/ /;
$jobs =~ s/^\s*//;
$jobs =~ s/^\t*//;
$jobs =~ s/\s*$//;
$jobs =~ s/\r//g;
$jobs =~ s/\n\s*/\n/g;

if (!&lockFile($NAMEDLOCKFILE, "$WBMC_LOCK_W_B", *LOCK)) {
	$err = "$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
	&showErrorPage("$err");
	exit(1);
}

$tmpcfname = "$cfname\.tmp";
if (!open(OUT, "> $tmpcfname")) {
	close(LOCK);
	$err = "$STR_ERR_CANTOPENFILE($tmpcfname)";
	&showErrorPage("$err");
	exit(1);
}
$fp = OUT;
$string = "";
$string = sprintf( "%s\n", $jobs );
$len = length( $string );
$err = syswrite( $fp, $string, $len );

close(OUT);

close(LOCK);

if ($err == $len) {
	rename($tmpcfname, $cfname);
}
else {
	unlink($tmpcfname);
	$err = "$STR_ERR_CANTWRITEFILE($tmpcfname)";
	&showErrorPage("$err");
	exit(1);
}
#---------------------------------------------------------------------------
# Ÿ۾θꥸ
#---------------------------------------------------------------------------
$cfname = $PFAILJOBCONFIG;

&readParam();

$jobs = $FORM{'PFAIL_JOB'};
$jobs =~ s/,/ /;
$jobs =~ s/^\s*//;
$jobs =~ s/^\t*//;
$jobs =~ s/\s*$//;
$jobs =~ s/\r//g;
$jobs =~ s/\n\s*/\n/g;

if (!&lockFile($NAMEDLOCKFILE, "$WBMC_LOCK_W_B", *LOCK)) {
	$err = "$STR_ERR_CANTLOCK($NAMEDLOCKFILE)";
	&showErrorPage("$err");
	exit(1);
}

$tmpcfname = "$cfname\.tmp";
if (!open(OUT, "> $tmpcfname")) {
	close(LOCK);
	$err = "$STR_ERR_CANTOPENFILE($tmpcfname)";
	&showErrorPage("$err");
	exit(1);
}
$fp = OUT;
$string = "";
$string = sprintf( "%s\n", $jobs );
$len = length( $string );
$err = syswrite( $fp, $string, $len );

close(OUT);

close(LOCK);

if ($err == $len) {
	rename($tmpcfname, $cfname);
}
else {
	unlink($tmpcfname);
	$err = "$STR_ERR_CANTWRITEFILE($tmpcfname)";
	&showErrorPage("$err");
	exit(1);
}

&showResultPage("λޤȿǤ뤿ˡESMPRO/ACΥӥƵưƤ", "esmac.cgi");
exit(0);
#---------------------------------------------------------------------------
